#include <iomanip>
#include <memory>
#include <chrono>
#include <vector>
#include <tuple>
#include <fstream>
#include <cuda.h>
#include <cudnn.h>
#include <iostream>
#include <sstream>
#include <cstdint>
#include "half.hpp"
#include "Norm_conv.h"


int main(){
    using half_float::half;
    CuDNNNormConvolutionOp<half> op;

    op.Init();

    auto in_data = rand<half>(std::vector<int>{128, 64, 56, 56}, 100);
    
    auto weight = rand<half>(std::vector<int>{256, 64, 1, 1}, 100);
    
    auto out_data = zeros<half>(std::vector<int>{256, 64, 1, 1});

    auto out_sum = zeros<float>(std::vector<int>{128, 256, 56, 56});

    auto out_sum_of_squares = zeros<float>(std::vector<int>{256});

    op.Forward(in_data, weight, out_data, out_sum, out_sum_of_squares);
}